import "./style.css";
import { reactive as k, ref as w, watchEffect as L, onActivated as N, nextTick as x, onBeforeUnmount as j, resolveComponent as g, openBlock as B, createElementBlock as D, createElementVNode as c, createVNode as f, withCtx as I, withDirectives as T, vShow as F, pushScopeId as O, popScopeId as W } from "vue";
import { Button as A } from "@opentiny/vue";
import { VueMonaco as P, CloseIcon as V } from "@opentiny/tiny-engine-common";
import { initCompletion as J } from "@opentiny/tiny-engine-common/js/completion";
import { lint as z, initLinter as H } from "@opentiny/tiny-engine-common/js/linter";
import { theme as R } from "@opentiny/tiny-engine-controller/adapter";
import { useModal as U, useCanvas as C, useNotify as Y } from "@opentiny/tiny-engine-controller";
import { insertName as q, string2Ast as S, ast2String as G } from "@opentiny/tiny-engine-common/js/ast";
import { constants as K } from "@opentiny/tiny-engine-utils";
import { getSchema as M } from "@opentiny/tiny-engine-canvas";
import { isFunction as Q } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: X } = K, { message: Z, confirm: $ } = U(), s = k({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null
}), a = w(null);
let m = null;
const p = () => {
  var o;
  const t = ((o = M) == null ? void 0 : o()) || {};
  return t.methods = (t == null ? void 0 : t.methods) || {}, t.methods;
}, tt = () => C().pageState.pageSchema && Object.keys(p()) || [], v = () => {
  const o = Object.entries(p()).map(([e, n]) => q(e, n.value)).join(`
`);
  return m = S(o), o;
}, et = (t) => {
  if (s.isChanged = t !== s.script, !a.value)
    return;
  const o = a.value.getEditor().getModel();
  z(o, s.linterWorker);
}, y = ({ name: t, content: o }) => {
  if (!t)
    return;
  const e = p();
  e[t] || (e[t] = {
    type: X.JSFunction,
    value: ""
  }), e[t].value = o;
}, E = () => {
  if (!s.isChanged)
    return !1;
  if (s.hasError)
    return Z({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const t = a.value.getEditor().getValue(), o = S(t);
  return M().methods = {}, o.program.body.forEach((e, n) => {
    var l, d;
    const i = (l = e == null ? void 0 : e.id) == null ? void 0 : l.name;
    (d = o.program.body[n + 1]) != null && d.leadingComments && e.trailingComments === o.program.body[n + 1].leadingComments && delete e.trailingComments;
    const r = G(e).trim();
    y({ name: i, content: r });
  }), C().pageState.isSaved = !1, s.isChanged = !1, Y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, ot = (t) => (o) => {
  const e = Q(o) ? o : () => t("close");
  if (!s.isChanged) {
    e(!0);
    return;
  }
  $({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      e(E());
    },
    cancel() {
      e(!0);
    }
  });
}, nt = () => {
  if (!s.editorSelection || !a.value)
    return;
  const t = a.value.getEditor();
  t.setSelection(s.editorSelection), t.focus();
  const o = t.getTopForLineNumber(s.editorSelection.startLineNumber - 1);
  t.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: o
    },
    0
  );
}, st = (t) => {
  var n;
  if (!t)
    return;
  const o = m == null ? void 0 : m.program.body.filter((i) => {
    var r;
    return t === ((r = i == null ? void 0 : i.id) == null ? void 0 : r.name);
  });
  if (o.length === 0)
    return;
  const e = (n = o[0]) == null ? void 0 : n.loc;
  e && (s.editorSelection = {
    startColumn: e.start.column,
    startLineNumber: e.start.line,
    endColumn: e.end.column + 1,
    endLineNumber: e.end.line
  }), s.editorSelection && nt();
}, it = ({ emit: t }) => (L(() => {
  s.script = v();
}), N(() => {
  x(() => {
    var o;
    s.script = v(), (o = a.value) == null || o.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: s,
  monaco: a,
  change: et,
  saveMethods: E,
  close: ot(t)
});
const rt = (t, o) => {
  const e = t.__vccOpts || t;
  for (const [n, i] of o)
    e[n] = i;
  return e;
}, ct = {
  saveMethod: y,
  highlightMethod: st,
  getMethodNameList: tt,
  getMethods: p
}, at = {
  components: {
    MonacoEditor: P,
    TinyButton: A,
    CloseIcon: V
  },
  emits: ["close"],
  setup(t, { emit: o }) {
    const { state: e, monaco: n, change: i, close: r, saveMethods: l } = it({ emit: o }), d = {
      roundedSelection: !0,
      automaticLayout: !0,
      autoIndent: !0,
      language: "javascript",
      formatOnPaste: !0,
      tabSize: 2,
      theme: R(),
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, h = (u) => {
      n.value && (J(n.value.getMonaco()), e.linterWorker = H(u, n.value.getMonaco(), e));
    };
    return j(() => {
      var u, _;
      (_ = (u = e.linterWorker) == null ? void 0 : u.terminate) == null || _.call(u);
    }), {
      state: e,
      monaco: n,
      options: d,
      close: r,
      change: i,
      saveMethods: l,
      editorDidMount: h
    };
  }
}, b = (t) => (O("data-v-28973542"), t = t(), W(), t), lt = { class: "plugin-page-js-container" }, dt = { class: "code-edit-head" }, ut = /* @__PURE__ */ b(() => /* @__PURE__ */ c("div", { class: "head-left" }, [
  /* @__PURE__ */ c("span", { class: "title" }, "页面 JS")
], -1)), mt = { class: "head-right" }, pt = /* @__PURE__ */ b(() => /* @__PURE__ */ c("span", null, "保存", -1)), ht = { class: "dots" }, gt = { class: "code-edit-content" };
function ft(t, o, e, n, i, r) {
  const l = g("tiny-button"), d = g("close-icon"), h = g("monaco-editor");
  return B(), D("div", lt, [
    c("div", dt, [
      ut,
      c("div", mt, [
        f(l, {
          type: "primary",
          class: "save-btn",
          onClick: n.saveMethods
        }, {
          default: I(() => [
            pt,
            T(c("span", ht, null, 512), [
              [F, n.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        f(d, { onClose: n.close }, null, 8, ["onClose"])
      ])
    ]),
    c("div", gt, [
      f(h, {
        ref: "monaco",
        value: n.state.script,
        options: n.options,
        onChange: n.change,
        onEditorDidMount: n.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const _t = /* @__PURE__ */ rt(at, [["render", ft], ["__scopeId", "data-v-28973542"]]), jt = {
  id: "PageController",
  title: "页面 JS",
  icon: "plugin-icon-js",
  align: "top",
  api: ct,
  component: _t,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
};
export {
  jt as default
};
